/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import { Tensor, Tensor1D, Tensor2D, Tensor3D, Tensor4D } from '@tensorflow/tfjs-core';
/**
 * Converts a `tf.Tensor` to a `tf.Tensor1D`.
 * @doc {heading: 'Tensors', subheading: 'Classes'}
 */
export declare function as1D<T extends Tensor>(thiz: T): Tensor1D;
export declare function as2D<T extends Tensor>(thiz: T, rows: number, columns: number): Tensor2D;
export declare function as3D<T extends Tensor>(thiz: T, rows: number, columns: number, depth: number): Tensor3D;
export declare function as4D<T extends Tensor>(thiz: T, rows: number, columns: number, depth: number, depth2: number): Tensor4D;
