/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import { reshape } from '@tensorflow/tfjs-core';
/**
 * Converts a `tf.Tensor` to a `tf.Tensor1D`.
 * @doc {heading: 'Tensors', subheading: 'Classes'}
 */
export function as1D(thiz) {
    thiz.throwIfDisposed();
    return reshape(thiz, [thiz.size]);
}
;
export function as2D(thiz, rows, columns) {
    thiz.throwIfDisposed();
    return reshape(thiz, [rows, columns]);
}
;
export function as3D(thiz, rows, columns, depth) {
    thiz.throwIfDisposed();
    return reshape(thiz, [rows, columns, depth]);
}
;
export function as4D(thiz, rows, columns, depth, depth2) {
    thiz.throwIfDisposed();
    return reshape(thiz, [rows, columns, depth, depth2]);
}
//# sourceMappingURL=as.js.map