import { __awaiter, __generator } from "tslib";
export function nonMaxSuppression(boxes, scores, maxOutputSize, iouThreshold, scoreThreshold) {
    return __awaiter(this, void 0, void 0, function () {
        var numBoxes, outputSize, candidates, suppressFunc, selected, _i, candidates_1, c, originalScore, j, iou, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    numBoxes = boxes.shape[0];
                    outputSize = Math.min(maxOutputSize, numBoxes);
                    candidates = scores
                        .map(function (score, boxIndex) { return ({ score: score, boxIndex: boxIndex }); })
                        .filter(function (c) { return c.score > scoreThreshold; })
                        .sort(function (c1, c2) { return c2.score - c1.score; });
                    suppressFunc = function (x) { return x <= iouThreshold ? 1 : 0; };
                    selected = [];
                    _i = 0, candidates_1 = candidates;
                    _b.label = 1;
                case 1:
                    if (!(_i < candidates_1.length)) return [3 /*break*/, 7];
                    c = candidates_1[_i];
                    if (selected.length >= outputSize) {
                        return [3 /*break*/, 6];
                    }
                    originalScore = c.score;
                    j = selected.length - 1;
                    _b.label = 2;
                case 2:
                    if (!(j >= 0)) return [3 /*break*/, 5];
                    _a = IOU;
                    return [4 /*yield*/, boxes.array()];
                case 3:
                    iou = _a.apply(void 0, [_b.sent(), c.boxIndex, selected[j]]);
                    if (iou === 0.0) {
                        return [3 /*break*/, 4];
                    }
                    c.score *= suppressFunc(iou);
                    if (c.score <= scoreThreshold) {
                        return [3 /*break*/, 5];
                    }
                    _b.label = 4;
                case 4:
                    --j;
                    return [3 /*break*/, 2];
                case 5:
                    if (originalScore === c.score) {
                        selected.push(c.boxIndex);
                    }
                    _b.label = 6;
                case 6:
                    _i++;
                    return [3 /*break*/, 1];
                case 7: return [2 /*return*/, selected];
            }
        });
    });
}
function IOU(boxesData, i, j) {
    var yminI = Math.min(boxesData[i][0], boxesData[i][2]);
    var xminI = Math.min(boxesData[i][1], boxesData[i][3]);
    var ymaxI = Math.max(boxesData[i][0], boxesData[i][2]);
    var xmaxI = Math.max(boxesData[i][1], boxesData[i][3]);
    var yminJ = Math.min(boxesData[j][0], boxesData[j][2]);
    var xminJ = Math.min(boxesData[j][1], boxesData[j][3]);
    var ymaxJ = Math.max(boxesData[j][0], boxesData[j][2]);
    var xmaxJ = Math.max(boxesData[j][1], boxesData[j][3]);
    var areaI = (ymaxI - yminI) * (xmaxI - xminI);
    var areaJ = (ymaxJ - yminJ) * (xmaxJ - xminJ);
    if (areaI <= 0 || areaJ <= 0) {
        return 0.0;
    }
    var intersectionYmin = Math.max(yminI, yminJ);
    var intersectionXmin = Math.max(xminI, xminJ);
    var intersectionYmax = Math.min(ymaxI, ymaxJ);
    var intersectionXmax = Math.min(xmaxI, xmaxJ);
    var intersectionArea = Math.max(intersectionYmax - intersectionYmin, 0.0) *
        Math.max(intersectionXmax - intersectionXmin, 0.0);
    return intersectionArea / (areaI + areaJ - intersectionArea);
}
//# sourceMappingURL=nonMaxSuppression.js.map